package net.ko.design;

import net.ko.mapping.KAjaxObject;
import net.ko.utils.KString;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KCssOneTransition extends KAjaxObject {
	private String property;
	private String startValue;
	private String endValue;
	private String duration;
	private String timing;

	public KCssOneTransition() {
		super();
	}

	@Override
	public String createFunction() {
		String sv = "";
		if (KString.isNotNull(startValue))
			sv = "startValue:'" + startValue + "',";
		String ev = "";
		if (KString.isNotNull(endValue))
			ev = "endValue:'" + endValue + "',";
		return "{property:'" + property + "'," + sv + ev + "duration:'" + duration + "s " + timing + "'}";
	}

	@Override
	public boolean isValid() {
		return KString.isNotNull(property);
	}

	@Override
	public void initFromXml(Node item) {
		Element e = (Element) item;
		property = e.getAttribute("property");
		startValue = e.getAttribute("startValue");
		endValue = e.getAttribute("endValue");
		duration = e.getAttribute("duration");
		timing = e.getAttribute("timing");
		if (KString.isNull(duration))
			duration = "1";
		if (KString.isNull(timing))
			timing = "linear";
	}

	public KCssOneTransition(String property, String startValue, String endValue, String duration, String timing) {
		super();
		this.property = property;
		this.startValue = startValue;
		this.endValue = endValue;
		this.duration = duration;
		this.timing = timing;
	}

	@Override
	public String getDisplayCaption() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getDebugClientId() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
