package net.ko.mapping;

import net.ko.types.KStringsType;
import net.ko.utils.KString;
import net.ko.utils.KStrings;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxDeleteOne extends KAjaxInclude {
	protected String kobjectShortClassName;
	protected String updateMessageMask;
	protected String errorMessageMask;

	public KAjaxDeleteOne() {
		super();
		updateMessageMask = "{toString} supprimé";
		errorMessageMask = "Erreur de suppression";
	}

	@Override
	public void initFromXml(Node item) {
		super.initFromXml(item);
		Element e = (Element) item;

		String strURL = e.getAttribute("virtualURL");
		if (KString.isNotNull(strURL))
			targetURL = strURL;
		else
			targetURL = "/deleteOne.frm";
		this.kobjectShortClassName = e.getAttribute("kobjectShortClassName");
		if (kobjectShortClassName != null && !"".equals(kobjectShortClassName)) {
			String targetParams = e.getAttribute("targetParams");
			if (targetParams != null)
				this.targetParams = targetParams.replace(",", "&");
			parameters = new KStrings(this.targetParams, KStringsType.kstQueryString);
			String keyValues = e.getAttribute("keyValues");
			if (KString.isNull(keyValues)) {
				keyValues = "{js:$('list-" + kobjectShortClassName + "').selector.getValue()}";
			}
			parameters.put("_keyValues", keyValues);
			parameters.put("_cls", kobjectShortClassName);
		}
		String _updateMessageMask = KString.urlEncode(e.getAttribute("updateMessageMask"));
		if (_updateMessageMask != null && !"".equals(_updateMessageMask))
			updateMessageMask = _updateMessageMask;

		String _errorMessageMask = KString.urlEncode(e.getAttribute("errorMessageMask"));
		if (_errorMessageMask != null && !"".equals(_errorMessageMask))
			errorMessageMask = _errorMessageMask;
		parameters.put("_uMM", KString.urlEncode(updateMessageMask));
		parameters.put("_eMM", KString.urlEncode(errorMessageMask));
		setMethod(e.getAttribute("method"));
	}

	@Override
	public boolean isValid() {
		boolean result = super.isValid() && kobjectShortClassName != null;
		return result;
	}

	public String getKobjectShortClassName() {
		return kobjectShortClassName;
	}

	public void setKobjectShortClassName(String kobjectShortClassName) {
		this.kobjectShortClassName = kobjectShortClassName;
	}

	public String getupdateMessageMask() {
		return updateMessageMask;
	}

	public void setupdateMessageMask(String updateMessageMask) {
		this.updateMessageMask = updateMessageMask;
	}

	public String getErrorMessageMask() {
		return errorMessageMask;
	}

	public void setErrorMessageMask(String errorMessageMask) {
		this.errorMessageMask = errorMessageMask;
	}

	@Override
	public KStrings getTitles() {
		KStrings titles = super.getTitles();
		titles.put("kobjectShortClassName", kobjectShortClassName);
		return titles;
	}

	@Override
	public String getName() {
		return "DeleteOne";
	}

	@Override
	public void setMethod(String method) {
		if (method == null || "".equals(method)) {
			method = "post";
		}
		this.method = method.toLowerCase();
	}
}
