package net.ko.mapping;

import net.ko.utils.KString;
import net.ko.utils.KStrings;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxDialogButton extends KAjaxWithChilds {
	protected String caption;
	protected int keyCode = -1;
	protected String id;

	protected KAjaxMessageDialog dialog;

	public KAjaxDialogButton() {
		super();
	}

	@Override
	public String createMyOwnFunction(String childFunctions) {
		return childFunctions;
	}

	@Override
	public String createFunction() {
		String result = createMyOwnFunction(getFunctions());
		result = addDeboggerExpression(result, getName() + ":" + getDebugClientId() + "->" + keyCode, createMyOwnFunction(""));
		return result;
	}

	@Override
	public boolean isValid() {
		return caption != null;
	}

	@Override
	public void initFromXml(Node item) {
		Element e = (Element) item;
		this.caption = e.getAttribute("caption");
		this.id = e.getAttribute("id");
		String strKeyCode = e.getAttribute("keyCode");
		if (strKeyCode != null && !"".equals(strKeyCode)) {
			try {
				this.keyCode = Integer.valueOf(strKeyCode);
			} catch (Exception ex) {
				keyCode = -1;
			}
		}
		childs = KAjaxJs.getChilds(item, true, isInRootFolder);
		boolean breakPoint = KString.isBooleanTrue(e.getAttribute("break"));
		setBreakPoint(breakPoint);
	}

	@Override
	public String toString() {
		String result = createFunction();
		result = getPreludeFunction() + result + "}";
		return result;
	}

	public String getCaption() {
		return caption;
	}

	public void setCaption(String caption) {
		this.caption = caption;
	}

	public int getKeyCode() {
		if (keyCode == -1)
			return 0;
		return keyCode;
	}

	public void setKeyCode(int keyCode) {
		this.keyCode = keyCode;
	}

	public String getButtons() {
		String strFunctions = getFunctions();
		boolean hasId = KString.isNotNull(id);
		String strId = "'" + id + "'";
		if (!hasId)
			strId = "undefined";
		if (!"".equals(strFunctions))
			return "{\"id\":" + strId + ",\"caption\":\"" + KString.jsQuote(caption) + "\",\"keyCode\":" + getKeyCode() + ",\"action\":" + getFunctions() + "}";
		else
			return "{\"id\":" + strId + ",\"caption\":\"" + KString.jsQuote(caption) + "\",\"keyCode\":" + getKeyCode() + "}";
	}

	@Override
	public String getDisplayCaption() {
		return caption;
	}

	@Override
	public String getDebugClientId() {
		return "#" + getDOMId();
	}

	@Override
	public String getName() {
		return "Button";
	}

	@Override
	public KStrings getTitles() {
		KStrings result = super.getTitles();
		result.put("caption", caption);
		result.put("keyCode", keyCode);
		return result;
	}

	public KAjaxMessageDialog getDialog() {
		return dialog;
	}

	public void setDialog(KAjaxMessageDialog dialog) {
		this.dialog = dialog;
	}

	public String getDOMId() {
		String result = "";
		if (dialog != null) {
			result = dialog.getDOMId() + "-";
		}
		result += KString.cleanHTMLAttribute(caption) + "-boxBtn";
		return result;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
}
