package net.ko.mapping;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.ko.framework.KDebugConsole;

public class KAjaxIncludes extends KFilterMappings {

	public KAjaxIncludes() {
		super();
	}

	@Override
	public boolean process(HttpServletRequest request, HttpServletResponse response) {
		boolean result = false;
		for (KAbstractFilterMapping ajaxRequest : items) {
			synchronized (ajaxRequest) {
				if (ajaxRequest.matches(request)) {
					if (ajaxRequest.execute(request, response)) {
						result = true;
						KDebugConsole.print(request.getRequestURI(), "AJAX", "KAjaxIncludes.process");
					}
				} else
					ajaxRequest.setOut("");
			}
		}
		return result;
	}

	public boolean processByName(String name) {
		boolean result = false;
		for (KAbstractFilterMapping ajaxRequest : items) {
			synchronized (ajaxRequest) {
				if (ajaxRequest.getRequestURL().equals(name)) {
					if (ajaxRequest.executeByName(name)) {
						result = true;
						KDebugConsole.print(name, "AJAX", "KAjaxIncludes.process");
					}
				} else
					ajaxRequest.setOut("");
			}
		}
		return result;
	}
}
