package net.ko.mapping;

import net.ko.utils.KString;
import net.ko.utils.KStrings;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxRefreshControl extends KAjaxObject {
	private KAjaxInclude ajaxInclude;
	private String name;
	private String className;
	private String controlType;
	private String filterList;
	private String value;
	private String koDisplay;
	private String condition;
	private String virtualURL;

	public KAjaxRefreshControl() {
		super();
		ajaxInclude = new KAjaxInclude();
	}

	@Override
	public String createFunction() {
		return ajaxInclude.createFunction();
	}

	@Override
	public boolean isValid() {
		return ajaxInclude.isValid();
	}

	@Override
	public void initFromXml(Node item) {
		Element e = (Element) item;
		name = e.getAttribute("name");
		className = e.getAttribute("kobjectShortClassName");
		value = e.getAttribute("value");
		filterList = e.getAttribute("filterList");
		controlType = e.getAttribute("controlType");
		koDisplay = e.getAttribute("koDisplay");
		condition = e.getAttribute("condition");
		virtualURL = e.getAttribute("virtualURL");
		ajaxInclude.setTargetId("field-" + name);
		ajaxInclude.setCondition(condition);

		ajaxInclude.setTargetURL(virtualURL);
		String params = "";
		params = addParam(params, "_name", name);
		params = addParam(params, "_className", className);
		params = addParam(params, "_value", value, false);
		params = addParam(params, "_filterList", filterList);
		params = addParam(params, "_controlType", controlType);
		params = addParam(params, "_koDisplay", koDisplay);
		params = addParam(params, "_virtualURL", virtualURL);
		ajaxInclude.setTargetParams(params);
		ajaxInclude.setMethod("POST");
		// ajaxInclude.setTargetFunction("function(){Forms.Utils.fireEvent($('"
		// + name + "'),'change');}");
		ajaxInclude.setChilds(KAjaxJs.getChilds(item, true, isInRootFolder));
	}

	private String addParam(String params, String paramName, String paramValue) {
		return addParam(params, paramName, paramValue, true);
	}

	private String addParam(String params, String paramName, String paramValue, boolean encoding) {
		String result = params;

		if (paramValue != null && !"".equals(paramValue)) {
			if (encoding)
				paramValue = KString.urlEncode(paramValue);
			if (!"".equals(result))
				result += "&" + paramName + "=" + paramValue;
			else
				result += paramName + "=" + paramValue;
		}
		return result;
	}

	@Override
	public String getDisplayCaption() {
		return ajaxInclude.getDisplayCaption();
	}

	@Override
	public String toString() {
		ajaxInclude.setChild(isChild);
		return ajaxInclude.toString();
	}

	@Override
	public String getDebugClientId() {
		return "#field-" + name;
	}

	@Override
	public String getName() {
		return "RefreshControl";
	}

	@Override
	public KStrings getTitles() {
		KStrings titles = super.getTitles();
		titles.put("virtualURL", virtualURL);
		titles.put("className", className);
		if (KString.isNotNull(condition))
			titles.put("condition", KString.htmlSpecialChars(condition));
		if (KString.isNotNull(controlType))
			titles.put("controlType", controlType);
		if (KString.isNotNull(filterList))
			titles.put("filterList", filterList);
		if (KString.isNotNull(koDisplay))
			titles.put("koDisplay", koDisplay);
		return titles;
	}

}
