package net.ko.mapping;

import net.ko.types.KStringsType;
import net.ko.utils.KString;
import net.ko.utils.KStrings;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxRefreshFormValues extends KAjaxInclude {
	protected String className;
	protected String keyValues;
	protected String excludedFields;

	@Override
	public boolean isValid() {
		return KString.isNotNull(keyValues) && KString.isNotNull(className);
	}

	@Override
	public void initFromXml(Node item) {
		Element e = (Element) item;
		className = e.getAttribute("kobjectShortClassName");
		keyValues = e.getAttribute("keyValues");
		excludedFields = e.getAttribute("excludedFields");
		condition = e.getAttribute("condition");
		targetURL = e.getAttribute("virtualURL");
		targetId = "";
		parameters = new KStrings(KStringsType.kstQueryString);
		parameters.put("_className", className);
		parameters.put("_keyValues", KString.urlEncode(keyValues));
		parameters.put("_excludedFields", KString.urlEncode(excludedFields));
		setMethod("get");
		childs = KAjaxJs.getChilds(item, true, isInRootFolder);
		boolean breakPoint = KString.isBooleanTrue(e.getAttribute("break"));
		setBreakPoint(breakPoint);
	}

	@Override
	public String getName() {
		return "RefreshFormValues";
	}
}
