package net.ko.mapping;

import net.ko.types.KStringsType;
import net.ko.utils.KString;
import net.ko.utils.KStrings;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxSubmitForm extends KAjaxInclude {
	protected String kobjectShortClassName;
	protected String updateMessageMask;
	protected String noUpdateMessageMask;
	protected String errorMessageMask;
	protected boolean validation;

	public KAjaxSubmitForm() {
		super();
		updateMessageMask = "{toString} enregistré";
		noUpdateMessageMask = "Aucune action effectuée sur {toString}";
		errorMessageMask = "Erreur pendant l'enregistrement de {toString}";
		validation = true;
	}

	@Override
	public void initFromXml(Node item) {
		super.initFromXml(item);
		Element e = (Element) item;
		String sep = "";
		String strURL = e.getAttribute("virtualURL");
		if (KString.isNotNull(strURL))
			targetURL = strURL;
		else
			targetURL = "/submitForm.frm";
		this.kobjectShortClassName = e.getAttribute("kobjectShortClassName");
		if (kobjectShortClassName != null && !"".equals(kobjectShortClassName)) {
			if (formName == null || "".equals(formName)) {
				formName = "frm" + kobjectShortClassName;
			}
			String strValidation = e.getAttribute("validation");
			if (KString.isBoolean(strValidation))
				validation = KString.isBooleanTrue(strValidation);
			setCondition(validation, condition);
			if (targetParams != null && !"".equals(targetParams)) {
				sep = "&";
			}
			targetParams += sep + "_cls=" + kobjectShortClassName;
		}
		if (targetParams == null || "".equals(targetParams))
			targetParams = "_keyValues={jsv:koKeyValue}";
		else {
			if (!targetParams.contains("{jsv:koKeyValue}"))
				targetParams += "&_keyValues={jsv:koKeyValue}";
		}
		String _updateMessageMask = e.getAttribute("updateMessageMask");
		if (_updateMessageMask != null && !"".equals(_updateMessageMask))
			updateMessageMask = _updateMessageMask;
		String _noUpdateMessageMask = e.getAttribute("noUpdateMessageMask");
		if (_noUpdateMessageMask != null && !"".equals(_noUpdateMessageMask))
			noUpdateMessageMask = _noUpdateMessageMask;
		String _errorMessageMask = e.getAttribute("errorMessageMask");
		if (_errorMessageMask != null && !"".equals(_errorMessageMask))
			errorMessageMask = _errorMessageMask;
		targetParams += "&_uMM=" + KString.urlEncode(updateMessageMask);
		targetParams += "&_nuMM=" + KString.urlEncode(noUpdateMessageMask);
		targetParams += "&_eMM=" + KString.urlEncode(errorMessageMask);
		setMethod(e.getAttribute("method"));
		parameters = new KStrings(this.targetParams, KStringsType.kstQueryString);
	}

	public void setCondition(boolean validation, String condition) {
		if (KString.isNotNull(condition)) {
			if (validation)
				this.condition = "(v" + formName + ".validate()==true) && (" + condition + ")";
			else
				this.condition = condition;
		} else {
			if (validation)
				this.condition = "v" + formName + ".validate()==true";
			else
				this.condition = "";
		}
	}

	public void initWith(String kobjectShortClassName, String formName, String condition, String targetParams, String updateMessageMask,
			String noUpdateMessageMask, String errorMessageMask, String method, boolean validation) {
		String sep = "";
		this.kobjectShortClassName = kobjectShortClassName;
		if (kobjectShortClassName != null && !"".equals(kobjectShortClassName)) {
			if (formName == null || "".equals(formName)) {
				this.formName = "frm" + kobjectShortClassName;
			}
			setCondition(validation, condition);
			if (targetParams != null && !"".equals(targetParams)) {
				sep = "&";
			}
			this.targetParams = targetParams + sep + "_cls=" + this.kobjectShortClassName;
		}
		if (this.targetParams == null || "".equals(this.targetParams))
			this.targetParams = "_keyValues={jsv:koKeyValue}";
		else {
			if (!this.targetParams.contains("{jsv:koKeyValue}"))
				this.targetParams += "&_keyValues={jsv:koKeyValue}";
		}
		String _updateMessageMask = KString.urlEncode(updateMessageMask);
		if (_updateMessageMask != null && !"".equals(_updateMessageMask))
			this.updateMessageMask = _updateMessageMask;
		String _noUpdateMessageMask = KString.urlEncode(noUpdateMessageMask);
		if (_noUpdateMessageMask != null && !"".equals(_noUpdateMessageMask))
			this.noUpdateMessageMask = _noUpdateMessageMask;
		String _errorMessageMask = KString.urlEncode(errorMessageMask);
		if (_errorMessageMask != null && !"".equals(_errorMessageMask))
			this.errorMessageMask = _errorMessageMask;
		this.targetParams += "&_uMM=" + KString.urlEncode(this.updateMessageMask);
		this.targetParams += "&_nuMM=" + KString.urlEncode(this.noUpdateMessageMask);
		this.targetParams += "&_eMM=" + KString.urlEncode(this.errorMessageMask);
		setMethod(method);
		parameters = new KStrings(this.targetParams, KStringsType.kstQueryString);
	}

	@Override
	public boolean isValid() {
		boolean result = super.isValid() && kobjectShortClassName != null;
		return result;
	}

	public String getKobjectShortClassName() {
		return kobjectShortClassName;
	}

	public void setKobjectShortClassName(String kobjectShortClassName) {
		this.kobjectShortClassName = kobjectShortClassName;
	}

	public String getUpdateMessageMask() {
		return updateMessageMask;
	}

	public void setUpdateMessageMask(String updateMessageMask) {
		this.updateMessageMask = updateMessageMask;
	}

	public String getNoUpdateMessageMask() {
		return noUpdateMessageMask;
	}

	public void setNoUpdateMessageMask(String noUpdateMessageMask) {
		this.noUpdateMessageMask = noUpdateMessageMask;
	}

	public String getErrorMessageMask() {
		return errorMessageMask;
	}

	public void setErrorMessageMask(String errorMessageMask) {
		this.errorMessageMask = errorMessageMask;
	}

	@Override
	public KStrings getTitles() {
		KStrings titles = super.getTitles();
		titles.put("kobjectShortClassName", kobjectShortClassName);
		return titles;
	}

	@Override
	public String getName() {
		return "SubmitForm";
	}
}
